import { AfterViewInit, EventEmitter, TemplateRef } from '@angular/core';
import { IqSelect2Item } from './iq-select2-item';
import { IqSelect2ResultsComponent } from '../iq-select2-results/iq-select2-results.component';
import { ControlValueAccessor, FormControl } from '@angular/forms';
import { Messages } from './messages';
import { Observable } from 'rxjs';
export declare class IqSelect2Component implements AfterViewInit, ControlValueAccessor {
    MORE_RESULTS_MSG: string;
    NO_RESULTS_MSG: string;
    dataSourceProvider: (term: string, selected?: any[]) => Observable<any[]>;
    selectedProvider: (ids: string[]) => Observable<any[]>;
    iqSelect2ItemAdapter: (entity: any) => IqSelect2Item;
    referenceMode: 'id' | 'entity';
    multiple: boolean;
    searchDelay: number;
    css: string;
    placeholder: string;
    minimumInputLength: number;
    disabled: boolean;
    searchIcon: any;
    deleteIcon: any;
    messages: Messages;
    resultsCount: any;
    clientMode: boolean;
    badgeColor: string;
    onSelect: EventEmitter<IqSelect2Item>;
    onRemove: EventEmitter<IqSelect2Item>;
    private termInput;
    results: IqSelect2ResultsComponent;
    templateRef: TemplateRef<any>;
    term: FormControl;
    resultsVisible: boolean;
    listData: IqSelect2Item[];
    fullDataList: IqSelect2Item[];
    selectedItems: IqSelect2Item[];
    searchFocused: boolean;
    private placeholderSelected;
    onTouchedCallback: () => void;
    onChangeCallback: (_: any) => void;
    constructor();
    ngAfterViewInit(): void;
    writeValue(selectedValues: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState(isDisabled: boolean): void;
    private subscribeToChangesAndLoadDataFromObservable();
    private subscribeToResults(observable);
    private loadDataFromObservable(term);
    private fetchAndfilterLocalData(term);
    private filterLocalData(term);
    private containsText(item, term);
    private fetchData(term);
    private adaptItems(items);
    private populateItemsFromEntities(selectedValues);
    private handleMultipleWithEntities(selectedValues);
    private populateItemsFromIds(selectedValues);
    private handleMultipleWithIds(selectedValues);
    private handleSingleWithId(id);
    private alreadySelected(item);
    onItemSelected(item: IqSelect2Item): void;
    private getSelectedIds();
    private getEntities();
    removeItem(item: IqSelect2Item): void;
    private buildValue();
    onFocus(): void;
    onBlur(): void;
    focus(): void;
    focusAndShowResults(): void;
    onKeyUp(ev: any): void;
    onKeyDown(ev: any): void;
    onKeyPress(ev: any): void;
    getCss(): string;
    getPlaceholder(): string;
    getCountMessage(): string;
    getBadgeColor(): string;
}
